import es

info = es.AddonInfo() 
info.name     = "Help script: Events" 
info.version  = "1.0" 
info.url      = "http://forums.mattie.info/cs/forums/viewtopic.php?t=16402"
info.basename = "help_events" 
info.author   = "GODJonez"

events = {}

def load():
    es.dbgmsg(0,"[help_events] Loading...")
    if not es.exists('command','he_loadevents'):
        es.regcmd('he_loadevents','help_events/consolecmd','Load .res file for help_events')
        es.set('he_track','1','Spam console on events?')
    gd = str(es.server_var['eventscripts_gamedir'])
    aod = gd + "/addons"
    es.dbgmsg(1,"[help_events] Game dir: %s"%gd)
    es.dbgmsg(1,"[help_events] Addon dir: %s"%aod)
    if not LoadEvents("hl2/resource/gameevents.res"):
        es.dbgmsg(0,"[help_events] Game events not found! (CRITICAL!)")
    if not LoadEvents("hl2/resource/hltvevents.res"):
        es.dbgmsg(0,"[help_events] HLTV events not found!")
    if not LoadEvents("hl2/resource/serverevents.res"):
        es.dbgmsg(0,"[help_events] Server events not found! (CRITICAL!)")
    if not LoadEvents("%s/resource/modevents.res"%gd):
        es.dbgmsg(0,"[help_events] MOD events not found! (BAD!)")
    if not LoadEvents("%s/mattie_eventscripts.res"%aod):
        es.dbgmsg(0,"[help_events] ES events not found! (OMGWTFBBQ!)")
    if not LoadEvents("%s/es_tools.res"%aod):
        es.dbgmsg(0,"[help_events] ES_Tools not found, est_ events not tracked")
    DirtyEShook()

def DirtyEShook():
    self = __import__('help_events')
    for event in events:
        es.addons.registerForEvent(self, event, EventHandler)

def EventHandler(event_var):
    if es.server_var['he_track'] != '0':
        event = str(event_var['es_event'])
        es.dbgmsg(0,"[help_events] ** %s **"%event)
        for attr in events[event]:
            value = str(event_var[attr])
            es.dbgmsg(0,"[help_events] %s = '%s'"%(attr,value))
        es.dbgmsg(0,"**")

def LoadEvents(fn):
    try:
        fh = open(fn, "r")
    except IOError:
        return False

    eventname = ""
    eventcount = 0
    level = 0
    for line in fh:
        l = line.split("//")[0].strip().replace('"','')
        if len(l) > 0:
            if l == '{':
                level = level + 1
            elif l == '}':
                level = level - 1
            elif level == 1:
                eventname = l
                events[eventname] = {}
                eventcount = eventcount + 1
                es.dbgmsg(1,"[help_events] Event: %s"%eventname)
            elif level == 2:
                params = l.split()
                events[eventname][params[0]] = params[1]
                es.dbgmsg(1,"[help_events] %s: %s"%(params[1],params[0]))
    
    fh.close()
    es.dbgmsg(0, "[help_events] %d events from %s" % (eventcount, fn))
    return True

def consolecmd():
    gd = str(es.server_var['eventscripts_gamedir'])
    fn = "%s/%s"%(gd,es.getargs())
    if not LoadEvents(fn):
        es.dbgmsg(0,"[help_events] File not found: %s",fn)
